/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.scd.calculate.domain.dto.AnalysisDataTransactionDTO
 *  com.deepexi.spa.commons.exception.ApplicationException
 *  com.deepexi.spa.commons.utils.StringUtils
 *  org.apache.commons.beanutils.BeanUtils
 */
package com.deepexi.scd.calculate.util;

import com.deepexi.scd.calculate.domain.dto.AnalysisDataTransactionDTO;
import com.deepexi.scd.calculate.util.DataCollectors;
import com.deepexi.spa.commons.exception.ApplicationException;
import com.deepexi.spa.commons.utils.StringUtils;
import java.lang.reflect.InvocationTargetException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;
import org.apache.commons.beanutils.BeanUtils;

public class AnalysisSummingMerge<T> {
    private List<T> list = new ArrayList<T>();
    private SummingMergeConfig<T> config = new SummingMergeConfig();

    public AnalysisSummingMerge(String valueSource, String[] groupBy, Function<T, BigDecimal> sumMapper) {
        this(groupBy, sumMapper);
        this.config.setValueSource(valueSource);
    }

    public AnalysisSummingMerge(String[] groupBy, Function<T, BigDecimal> sumMapper) {
        this.config.setGroupBy(groupBy);
        this.config.setSumMapper(sumMapper);
    }

    public void addAll(Collection<T> list) {
        this.list.addAll(list);
    }

    public List<AnalysisDataTransactionDTO> merge(Collection<T> list) {
        this.addAll(list);
        return this.merge();
    }

    public List<AnalysisDataTransactionDTO> merge() {
        if (this.list.size() == 0) {
            return new ArrayList<AnalysisDataTransactionDTO>();
        }
        ArrayList<AnalysisDataTransactionDTO> mergeList = new ArrayList<AnalysisDataTransactionDTO>();
        Map<String, BigDecimal> sumMap = DataCollectors.getSum(this.list, this::getGroupByStr, this.config.getSumMapper());
        sumMap.forEach((k, v) -> {
            AnalysisDataTransactionDTO returnDTO = new AnalysisDataTransactionDTO();
            returnDTO.setValue((BigDecimal)sumMap.get(k));
            String[] arrs = k.split(",", -1);
            if (StringUtils.isNotBlank((CharSequence)this.config.getValueSource())) {
                for (int i = 0; i < this.config.getGroupBy().length; ++i) {
                    String propertyName = "valueType";
                    if (i < this.config.getGroupBy().length - 1) {
                        propertyName = this.config.getGroupBy()[i];
                    }
                    this.setProperty(returnDTO, propertyName, arrs[i]);
                }
                this.setProperty(returnDTO, "valueSource", this.config.getValueSource());
            } else {
                for (int i = 0; i < this.config.getGroupBy().length; ++i) {
                    this.setProperty(returnDTO, this.config.getGroupBy()[i], arrs[i]);
                }
            }
            mergeList.add(returnDTO);
        });
        return mergeList;
    }

    private String getGroupByStr(Object bean) {
        List groupByValues = Arrays.stream(this.config.getGroupBy()).map(m -> {
            try {
                return BeanUtils.getProperty((Object)bean, (String)m);
            }
            catch (IllegalAccessException e) {
                e.printStackTrace();
            }
            catch (InvocationTargetException e) {
                e.printStackTrace();
            }
            catch (NoSuchMethodException e) {
                e.printStackTrace();
            }
            throw new ApplicationException("getGroupByStr异常");
        }).collect(Collectors.toList());
        return StringUtils.join(groupByValues, (String)",");
    }

    private void setProperty(Object bean, String propertyName, Object value) {
        BeanUtils.setProperty((Object)bean, (String)propertyName, (Object)value);
    }

    public static class SummingMergeConfig<T> {
        private String[] groupBy;
        private Function<T, BigDecimal> sumMapper;
        private String valueSource;

        public String[] getGroupBy() {
            return this.groupBy;
        }

        public Function<T, BigDecimal> getSumMapper() {
            return this.sumMapper;
        }

        public String getValueSource() {
            return this.valueSource;
        }

        public void setGroupBy(String[] groupBy) {
            this.groupBy = groupBy;
        }

        public void setSumMapper(Function<T, BigDecimal> sumMapper) {
            this.sumMapper = sumMapper;
        }

        public void setValueSource(String valueSource) {
            this.valueSource = valueSource;
        }

        public boolean equals(Object o) {
            if (o == this) {
                return true;
            }
            if (!(o instanceof SummingMergeConfig)) {
                return false;
            }
            SummingMergeConfig other = (SummingMergeConfig)o;
            if (!other.canEqual(this)) {
                return false;
            }
            if (!Arrays.deepEquals(this.getGroupBy(), other.getGroupBy())) {
                return false;
            }
            Function<T, BigDecimal> this$sumMapper = this.getSumMapper();
            Function<T, BigDecimal> other$sumMapper = other.getSumMapper();
            if (this$sumMapper == null ? other$sumMapper != null : !this$sumMapper.equals(other$sumMapper)) {
                return false;
            }
            String this$valueSource = this.getValueSource();
            String other$valueSource = other.getValueSource();
            return !(this$valueSource == null ? other$valueSource != null : !this$valueSource.equals(other$valueSource));
        }

        protected boolean canEqual(Object other) {
            return other instanceof SummingMergeConfig;
        }

        public int hashCode() {
            int PRIME = 59;
            int result = 1;
            result = result * 59 + Arrays.deepHashCode(this.getGroupBy());
            Function<T, BigDecimal> $sumMapper = this.getSumMapper();
            result = result * 59 + ($sumMapper == null ? 43 : $sumMapper.hashCode());
            String $valueSource = this.getValueSource();
            result = result * 59 + ($valueSource == null ? 43 : $valueSource.hashCode());
            return result;
        }

        public String toString() {
            return "AnalysisSummingMerge.SummingMergeConfig(groupBy=" + Arrays.deepToString(this.getGroupBy()) + ", sumMapper=" + this.getSumMapper() + ", valueSource=" + this.getValueSource() + ")";
        }
    }
}

